
; CC5X Version 3.2K, Copyright (c) B Knudsen Data
; C compiler for the PICmicro family
; ************   6. Apr 2007  10:22  *************

	processor  16F628
	radix  DEC

	__config 0x3F38

	EXTERN MedianFilter
INDF        EQU   0x00
PCL         EQU   0x02
STATUS      EQU   0x03
FSR         EQU   0x04
PCLATH      EQU   0x0A
INTCON      EQU   0x0B
Carry       EQU   0
Zero_       EQU   2
RP0         EQU   5
RP1         EQU   6
IRP         EQU   7

SHRAM    UDATA_SHR
_LcNA       RES   1
  GLOBAL _LcNA
TMR0        EQU   0x01
PORTA       EQU   0x05
PORTB       EQU   0x06
TMR1L       EQU   0x0E
TMR1H       EQU   0x0F
T1CON       EQU   0x10
CMCON       EQU   0x1F
RB0         EQU   0
RB1         EQU   1
RB3         EQU   3
RB4         EQU   4
RB5         EQU   5
TMR1IF      EQU   0
TMR1ON      EQU   0
PORTQ       EQU   0x05

BANK0    UDATA
lcdport     RES   1
  GLOBAL lcdport
Temperatur  RES   2
  GLOBAL Temperatur
t_low       RES   2
  GLOBAL t_low
t_high      RES   2
  GLOBAL t_high
temp_G      RES   2
  GLOBAL temp_G
temp_K      RES   2
  GLOBAL temp_K
Komp_OnTime RES   2
  GLOBAL Komp_OnTime
Komp_prtkt  RES   2
  GLOBAL Komp_prtkt
Text        RES   9
  GLOBAL Text
q           RES   4
  GLOBAL q
med_a       RES   2
  GLOBAL med_a
med_b       RES   2
  GLOBAL med_b
med_c       RES   2
  GLOBAL med_c
_LcNB       RES   10
  GLOBAL _LcNB
_GbitVB     RES   1
  GLOBAL _GbitVB
TRISA       EQU   0x85
TRISB       EQU   0x86
OPTION_REG  EQU   0x81

STARTUP CODE 0x0
	GOTO main

  ; FILE C:\projekte\picsel\dtemp_2\dtemp.c
			;/* DTEMP Digitaler Khlschrankregler mit TMP04 und LCD              */
			;/*                                                                  */
			;/* (c) C.Schirp  released for non-commercial use                    */
			;/* Division 24/16 (c) by Nikolai Golovchenko                        */
			;/* bin2dec999 (c) by Nikolai Golovchenko                            */
			;/* mul16 (c) by Scott Dattalo                                       */
			;/* LCD-Routinen (c) Holger Klabunde mit Anpassungen von mir         */
			;/*                                                                  */
			;/* V1.0 Erstausgabe                                                 */
			;/* V1.1 Int-Fehlerhandler, Fehler-LED                               */
			;/* V1.2 Medianfilter fr Temperaturen, Fehlerbits angepasst         */
			;/* V1.3 selbstdefinierte Zeichen, mplab wg. 1k-Grenze               */
			;/* V1.4 Fehlerbehandlung Sensorfehler verbessert,                   */
			;/*      Kommentare erw., Einschaltmeldung                           */
			;/*                                                                  */
			;
			;
			;#include <c:\projekte\picsel\cc5\16F628.h>
			;#include <c:\projekte\picsel\cc5\int16CXX.h>
			;#include <c:\projekte\picsel\cc5\inline.h>
			;#include <c:\projekte\picsel\dtemp_2\dtemp.h>
			;
			;#pragma config =0x3F38 
			;
			;// Standard ohne ext reset 0x3F18
			;// Standard mit ext Reset  0x3F38  
			;
			;/* Port- Defines */
			;
			;#define LCD_RS    0b.00010000             //RS-Pin ist Bit4, LCD Register Select
			;#define LCD_CS    0b.01000000             //E-Pin ist Bit6, LCD Chip Select
			;
			;#define KOMP_RELAIS RB3
			;#define LED_R   RB4
			;#define LED_G   RB5
			;
			;#define TMP_1   RB0
			;#define TMP_2	RB1
			;#define DOOR_OPEN RB2
			;
			;#pragma char PORTQ @ PORTA               //PORT auswhlen, DB7-Bit7, DB6-Bit6, DB5-Bit5, DB4-Bit4
			;
			;#define LCDCS_ON() { NOP;  NOP; lcdport|=LCD_CS; PORTQ=lcdport; }
			;#define LCDCS_OFF() { NOP;  NOP; lcdport&=~LCD_CS; PORTQ=lcdport; }
			;#define LCDRS_ON() { NOP;  NOP; lcdport|=LCD_RS; PORTQ=lcdport; }
			;#define LCDRS_OFF() { NOP; NOP; lcdport&=~LCD_RS; PORTQ=lcdport; }
			;
			;#define Wait() Delay1ms(10)
			;
			;void Komp_Aus(void);
			;
			;
			;//Kommandos fr das LCD-Display
			;#define CLEAR_DISPLAY 0x01
			;#define OFF_DISPLAY   0x08
			;#define CURSOR_OFF    0x0C
			;#define CURSOR_ON     0x0E
			;#define CURSOR_BLINK  0x0F
			;#define SHIFT_LEFT    0x18
			;#define SHIFT_RIGHT   0x1C
			;
			;/* Variablen */
			;
			;uns8 lcdport;
			;
			;bank0 int16 Temperatur;	// berechnete Temperatur (Zwischenspeicher)
			;bank0 uns16 t_low;	// gemessene Zeit LOW
			;bank0 uns16 t_high;	// gemessene Zeit HI
			;bank0 int16 temp_G;	// Temperatur Gefrierfach signed, gefiltert
			;bank0 int16 temp_K;	// Temperatur Kuehlfach signed, gefiltert
			;bank0 uns16 Komp_OnTime; // Zeit in s, die der Kompressor schon luft
			;bank0 uns16 Komp_prtkt;	// verbleibende Schutzzeit bis wiederanlauf
			;
			;unsigned char Text[9];	// Speicher fr eine LCD-Zeile incl Nullterminierung
			;
			;bank0 uns8 Komp_ON:1;	// Flag fr Kompressor eingeschaltet
			;bank0 uns8 F_SensorG:1;	// Flag fr Sensorfehler TMP1 / Gefrierfach
			;bank0 uns8 F_SensorK:1; // Flag fr Sensorfehler TMP2 / Kuehlfach
			;bank0 uns8 F_MotorMax:1;// Flag fr Motor-Maxlaufzeit
			;bank0 uns8 Komp_Req:1;	// Flag fr "kompressor erforderlich"
			;bank0 uns8 F_Frost:1;	// Falg fr Kompressor-ausschalten wg. Frostschutz
			;bank0 uns8 VZ_merker:1;	// Vorzeichenmerker und Hilfsbit
			;bank0 uns8 Blink:1;	// Bitcounter fr Alive-Anzeige im LCD
			;
			;uns8 q[4];	// Ergebnisvariable fr mul16by16
			;
			;int16 med_a;
			;int16 med_b;
			;int16 med_c;
			;
			;// Divisor und Dividend fr div24by16
			;//uns8 AARG[3];
			;//uns16 BARG;
			;
			;
			;/* defines fuer die SW */
			;
			;#define Hund Text+1
			;#define Tens Text+2
			;#define Ones Text+4
			;
			;//	AARG q[2]
			;//	AARG+1 q[1]
			;//	AARG+2 q[0]
			;		
			;//#define	BARG.low8 =t_low.high8;
			;//#define	BARG.high8=t_low.low8;
			;
			;#define KOMP_PROT 60	// 60 10er Sekunden Schutzzeit = 10Minuten
			;#define KOMP_MAXRUN 300  // 300 10er Sekunden Maxlaufzeit = 50 Minuten
			;#define G_TEMP_MAX ((int16)-5*17)	
			;#define G_TEMP_MIN ((int16)-5*22) 
			;#define K_TEMP_MAX ((int16)5*8) 
			;#define K_TEMP_MIN ((int16)32) 	// 6.4Grad
			;#define K_FROST_MIN ((int16)5*3) 
			;#define K_CHECK_MAX ((int16)5*40) // 40
			;#define K_CHECK_MIN ((int16)-5*35) // -35
			;#define K_FAIL_TEMP_K ((int16)5*6)
			;#define K_FAIL_TEMP_G ((int16)-5*23)
			;
			;
			;
			;#define CGRAM_LEN	24  //Anzahl zu bertragender Zeichen
			;
			;const unsigned char chardefs[] = {
			;//Adresse 0 im Character RAM
			;// 'raute'
			;0, 0x04, 0x0A, 0x11, 0x0A, 0x04, 0, 0,
			;
			;//Adresse 1 im Character RAM
			;// 'quadrat'
			;0, 0, 0x0e, 0x0a, 0x0e, 0, 0, 0,
			;
			;//Adresse 2 im Character RAM
			;// 'gefuelltes quadrat'
			;0, 0, 0x0e, 0x0e, 0x0e, 0, 0, 0,
			;
			;};
			;
			;
			;/*------------------------------------------------------------------*/
			;/*   II  N   N TTTTT                                                */
			;/*   II  NN  N   T                                                  */
			;/*   II  N N N   T                                                  */
			;/*   II  N  NN   T                                                  */
			;/*   II  N   N   T                                                  */
			;/*------------------------------------------------------------------*/
			;#pragma origin 4
			;interrupt int_server(void)
			;{

ISERVER CODE 0x4
int_server
			;	int_save_registers
	MOVWF _LcNA+0
	SWAPF STATUS,W
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF _LcNB+0
			;	
			;	// Eigentlich sind alle Ints gesprerrt - daher hier nur Fehlerled setzen
			;	
			;	LED_R = 0;
	BCF   0x06,RB4
			;	
			;	int_restore_registers
	SWAPF _LcNB+0,W
	MOVWF STATUS
	SWAPF _LcNA+0,1
	SWAPF _LcNA+0,W
			;}
	RETFIE
			;
			;
			;
			;/*------------------------------------------------------------------*/
			;/*   II  N   N  II TTTTT                                            */
			;/*   II  NN  N  II   T                                              */
			;/*   II  N N N  II   T                                              */
			;/*   II  N  NN  II   T                                              */
			;/*   II  N   N  II   T                                              */
			;/*------------------------------------------------------------------*/
			;
			;void init (void)
			;{

PROG    CODE
_const1
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF _LcNB+4
	BTFSC _LcNB+4,7
	GOTO  m001
	BCF   0x03,IRP
	MOVWF FSR
	MOVF  INDF,W
	RETURN
m001	MOVLW .170
	BCF   0x03,RP0
	BCF   0x03,RP1
	SUBWF _LcNB+4,W
	BTFSS 0x03,Carry
	GOTO  m002
	RETLW .0
m002	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVLW HIGH(Cgto1)
	MOVWF PCLATH
	MOVF  _LcNB+4,W
	ANDLW .127
	ADDLW LOW(Cgto1)
	BTFSC 0x03,Carry
	INCF  PCLATH,1
	MOVWF PCL
Cgto1
	RETLW .0
	RETLW .4
	RETLW .10
	RETLW .17
	RETLW .10
	RETLW .4
	RETLW .0
	RETLW .0
	RETLW .0
	RETLW .0
	RETLW .14
	RETLW .10
	RETLW .14
	RETLW .0
	RETLW .0
	RETLW .0
	RETLW .0
	RETLW .0
	RETLW .14
	RETLW .14
	RETLW .14
	RETLW .0
	RETLW .0
	RETLW .0
	RETLW .68
	RETLW .84
	RETLW .101
	RETLW .109
	RETLW .112
	RETLW .49
	RETLW .46
	RETLW .52
	RETLW .0
	RETLW .67
	RETLW .46
	RETLW .83
	RETLW .99
	RETLW .104
	RETLW .105
	RETLW .114
	RETLW .112
	RETLW .0
init
			;	/* PORT A, B Config */
			;	CMCON = 0x07;		// kein Komparator
	MOVLW .7
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF CMCON
			;	
			;	TRISB = 0b0000.0011; 	//Alles Ausgnge, 0,1 Eingaenge	
	MOVLW .3
	BSF   0x03,RP0
	MOVWF TRISB
			;	TRISA = 0b0010.0000;	// PA output, ra5 input
	MOVLW .32
	MOVWF TRISA
			;	
			;	PORTB = 0b0011.0000;	// HINT: erst Direction, dann Wert!
	MOVLW .48
	BCF   0x03,RP0
	MOVWF PORTB
			;	PORTA = 0x00;	
	CLRF  PORTA
			;
			;	/*sonstiges*/
			;	T1CON = 0x00;		// Timer disabled
	CLRF  T1CON
			;	OPTION_REG = 0x04;	/* pull-up portB, falling edge int, no WDT prescaler, prescale=32 */
	MOVLW .4
	BSF   0x03,RP0
	MOVWF OPTION_REG
			;	INTCON = 0; 		// reset and disable all interrupts by default
	CLRF  INTCON
			;
			;	/* Variablen initialisieren */
			;
			;	lcdport=0x80;	// alle low, nur bit 7 (VDD) auf 1
	MOVLW .128
	BCF   0x03,RP0
	MOVWF lcdport
			;	
			;	Text[5] =' ';	// Spaces im Text...
	MOVLW .32
	MOVWF Text+5
			;	Text[6] =' ';
	MOVLW .32
	MOVWF Text+6
			;	Text[7] =' ';
	MOVLW .32
	MOVWF Text+7
			;	
			;	Text[8] = 0;	// Nullterminierung fr LCD-String
	CLRF  Text+8
			;	
			;	temp_G = 0;	// Temperaturfilter initialisieren
	CLRF  temp_G
	CLRF  temp_G+1
			;	temp_K = 0;
	CLRF  temp_K
	CLRF  temp_K+1
			;	
			; 	F_SensorG=0;	// Fehlerflags loeschen
	BCF   _GbitVB+0,1
			;	F_SensorK=0;
	BCF   _GbitVB+0,2
			;	F_MotorMax=0;
	BCF   _GbitVB+0,3
			;	
			;	Komp_Aus();
	GOTO  Komp_Aus
			;
			;	
			;}
			;
			;/*------------------------------------------------------------------*/
			;/*   LL    CCCC DDD                                                 */
			;/*   LL   CC    DD DD                                               */
			;/*   LL   CC    DD  DD                                              */
			;/*   LL   CC    DD DD                                               */
			;/*   LLLLL CCCC DDD                                                 */
			;/*------------------------------------------------------------------*/
			;
			;void Delay1ms(uns16 ms)
			;{
Delay1ms
			;	while(ms)				// Schleife verlassen wen ms=0 ist
m003	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  _LcNB+8,W
	IORWF _LcNB+9,W
	BTFSC 0x03,Zero_
	GOTO  m006
			;	{
			;	    OPTION = 2; 		// Vorteiler auf 8 einstellen
	MOVLW .2
	BSF   0x03,RP0
	MOVWF OPTION_REG
			;	    TMR0 = 131; 		// 125 * 8 = 1000 (= 1 ms)
	MOVLW .131
	BCF   0x03,RP0
	MOVWF TMR0
			;	    while (TMR0);		// abwarten einer Milisekunde
m004	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  TMR0,W
	BTFSC 0x03,Zero_
	GOTO  m005
	GOTO  m004
			;	    ms--;				// "ms" mit jeder Milisekunde ernidrigen
m005	BCF   0x03,RP0
	BCF   0x03,RP1
	DECF  _LcNB+8,1
	INCF  _LcNB+8,W
	BTFSC 0x03,Zero_
	DECF  _LcNB+9,1
			;	}
	GOTO  m003
			;}
m006	RETURN
			;
			;//*******************************************
			;// Schreibt ein Datenbyte in die LCD-Anzeige
			;// Schreibt das Byte in zwei 4 Bit Nibbles
			;//*******************************************
			;
			;void LCDWriteByte (unsigned char data)
			;{
LCDWriteByte
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF _LcNB+6
			; unsigned char buff;
			; lcdport= PORTQ; 		//alten Wert merken
	MOVF  PORTQ,W
	MOVWF lcdport
			; LCDCS_OFF();
	NOP  
	NOP  
	BCF   lcdport,6
	MOVF  lcdport,W
	MOVWF PORTQ
			; buff=data>>4;   		//High Nibble des Bytes
	SWAPF _LcNB+6,W
	ANDLW .15
	MOVWF _LcNB+7
			; buff&=0x0F;			//Rest lschen
	MOVLW .15
	ANDWF _LcNB+7,1
			; lcdport=lcdport&0xF0;		//Hier D0-D3 lschen zum
	MOVLW .240
	ANDWF lcdport,1
			; lcdport|=buff;			//reinodern vom High Nibble
	MOVF  _LcNB+7,W
	IORWF lcdport,1
			; lcdport|=LCD_CS;
	BSF   lcdport,6
			; LCDCS_ON();	      		//High Nibble schreiben
	NOP  
	NOP  
	BSF   lcdport,6
	MOVF  lcdport,W
	MOVWF PORTQ
			;
			; LCDCS_OFF();
	NOP  
	NOP  
	BCF   lcdport,6
	MOVF  lcdport,W
	MOVWF PORTQ
			; buff=data&0x0F;        	//Low Nibble des Bytes
	MOVLW .15
	ANDWF _LcNB+6,W
	MOVWF _LcNB+7
			; lcdport=lcdport&0xF0;		//D0-D3  lschen zum
	MOVLW .240
	ANDWF lcdport,1
			; lcdport|=buff;			//reinodern vom Low Nibble
	MOVF  _LcNB+7,W
	IORWF lcdport,1
			; LCDCS_ON();	      		//Low Nibble schreiben
	NOP  
	NOP  
	BSF   lcdport,6
	MOVF  lcdport,W
	MOVWF PORTQ
			; LCDCS_OFF();
	NOP  
	NOP  
	BCF   lcdport,6
	MOVF  lcdport,W
	MOVWF PORTQ
			; Delay1ms(1);       		// warten
	MOVLW .1
	MOVWF _LcNB+8
	CLRF  _LcNB+9
	GOTO  Delay1ms
			;}
			;
			;//*****************************************
			;// Commando ans Display senden
			;//*****************************************
			;void LCDCommand(unsigned char mode)
			;{
LCDCommand
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF _LcNB+5
			; LCDRS_OFF(); 			//Controlregister
	NOP  
	NOP  
	BCF   lcdport,4
	MOVF  lcdport,W
	MOVWF PORTQ
			; LCDWriteByte(mode);
	MOVF  _LcNB+5,W
	CALL  LCDWriteByte
			; LCDRS_ON(); 			//Zurck auf Datenregister
	NOP  
	NOP  
	BCF   0x03,RP0
	BCF   0x03,RP1
	BSF   lcdport,4
	MOVF  lcdport,W
	MOVWF PORTQ
			;}
	RETURN
			;
			;//*****************************************
			;// Lscht die LCD Anzeige
			;// Cursor steht dann auf Position 1,Zeile 1
			;// Gilt auch fr mehrzeilige Anzeigen
			;//*****************************************
			;void LCDCls(void)
			;{
LCDCls
			; LCDRS_OFF(); //Controlregister
	NOP  
	NOP  
	BCF   0x03,RP0
	BCF   0x03,RP1
	BCF   lcdport,4
	MOVF  lcdport,W
	MOVWF PORTQ
			; LCDWriteByte(0x01); //CLS
	MOVLW .1
	CALL  LCDWriteByte
			; LCDRS_ON(); //Umschalten auf Datenregister
	NOP  
	NOP  
	BCF   0x03,RP0
	BCF   0x03,RP1
	BSF   lcdport,4
	MOVF  lcdport,W
	MOVWF PORTQ
			; Wait();
	MOVLW .10
	MOVWF _LcNB+8
	CLRF  _LcNB+9
	GOTO  Delay1ms
			;}
			;//**************************************************
			;//Schreibt einen Text in die LCD-Anzeige
			;//**************************************************
			;void LCDString(const char *__putstr)
			;{
LCDString
			;#pragma updateBank 0 /* OFF, all cores */
			; char __ps;
			;
			; __ps = *__putstr;
	MOVF  _LcNB+2,W
	CALL  _const1
	MOVWF _LcNB+3
			;
			;  while(__ps>0)
m007	MOVF  _LcNB+3,1
	BTFSC 0x03,Zero_
	GOTO  m009
			;   {
			;    __putstr++;
	INCF  _LcNB+2,1
			;    if (__ps== 0) break;
	MOVF  _LcNB+3,1
	BTFSS 0x03,Zero_
	GOTO  m008
	GOTO  m009
			;   LCDWriteByte(__ps);
m008	MOVF  _LcNB+3,W
	CALL  LCDWriteByte
			;    __ps = *__putstr;
	MOVF  _LcNB+2,W
	CALL  _const1
	MOVWF _LcNB+3
			;   }
	GOTO  m007
			;#pragma updateBank 1 /* ON, all cores */
			;}
m009	RETURN
			;//****************************************************
			;// Springt auf Zeile x und Position y der LCD-Anzeige
			;// Gltig fuer 2 Zeilen : 0,1.
			;//****************************************************
			;void LCDPos(unsigned char zeile,unsigned char position)
			;{
LCDPos
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF _LcNB+3
			;#pragma updateBank 0 /* OFF, all cores */
			;	 unsigned char buff;
			;	
			;	// 0x80 wegen Display Adress Set.
			;	// Erste Position ist bei mir  0.
			;	
			;	if (zeile)
	MOVF  _LcNB+2,1
	BTFSC 0x03,Zero_
	GOTO  m010
			;	{
			;		buff=0xC0+position;
	MOVLW .192
	ADDWF _LcNB+3,W
	MOVWF _LcNB+4
			;	}
			;	else
	GOTO  m011
			;	{
			;		buff=0x80+position;
m010	MOVLW .128
	ADDWF _LcNB+3,W
	MOVWF _LcNB+4
			;	}
			;	
			;	 LCDCommand(buff);
m011	MOVF  _LcNB+4,W
	GOTO  LCDCommand
			;#pragma updateBank 1 /* ON, all cores */
			;}
			;
			;
			;//*********************************************
			;//Stellt die Funktionsweise der LCD Anzeige ein
			;//*********************************************
			;
			;void LCDInit(void)
			;{
LCDInit
			; int i;
			;
			; LCDRS_OFF();  //Control Register
	NOP  
	NOP  
	BCF   0x03,RP0
	BCF   0x03,RP1
	BCF   lcdport,4
	MOVF  lcdport,W
	MOVWF PORTQ
			; LCDCS_OFF();  //LCD-Anzeige abwhlen
	NOP  
	NOP  
	BCF   lcdport,6
	MOVF  lcdport,W
	MOVWF PORTQ
			;
			;//Software Reset laut Hitachi Datenblatt
			; Delay1ms(60); //Mglichen Power On Reset abwarten
	MOVLW .60
	MOVWF _LcNB+8
	CLRF  _LcNB+9
	CALL  Delay1ms
			; for(i=0; i<3; i++)
	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  _LcNB+2
m012	BCF   0x03,RP0
	BCF   0x03,RP1
	BTFSC _LcNB+2,7
	GOTO  m013
	MOVLW .3
	SUBWF _LcNB+2,W
	BTFSC 0x03,Carry
	GOTO  m014
			;  {
			;   lcdport=lcdport&0xF0;//D0-D3 lschen
m013	MOVLW .240
	BCF   0x03,RP0
	BCF   0x03,RP1
	ANDWF lcdport,1
			;   lcdport|=0x03;	//Wert reinodern
	MOVLW .3
	IORWF lcdport,1
			;   PORTQ=lcdport;	//Auf den Port legen
	MOVF  lcdport,W
	MOVWF PORTQ
			;   LCDCS_OFF(); //LCD-Anzeige abwhlen
	NOP  
	NOP  
	BCF   lcdport,6
	MOVF  lcdport,W
	MOVWF PORTQ
			;   NOP;
	NOP  
			;   LCDCS_ON();	//High Nibble schreiben
	NOP  
	NOP  
	BSF   lcdport,6
	MOVF  lcdport,W
	MOVWF PORTQ
			;   Delay1ms(5); //Ein bichen warten auf die Anzeige
	MOVLW .5
	MOVWF _LcNB+8
	CLRF  _LcNB+9
	CALL  Delay1ms
			;  } 
	BCF   0x03,RP0
	BCF   0x03,RP1
	INCF  _LcNB+2,1
	GOTO  m012
			;//Ende Software Reset
			;
			;
			;//Der erste Schreibzugriff nach dem Reset ist ein 8 Bit
			;//Zugriff!! Also nur einmal schreiben, nicht Low-High Nibble.
			;
			;//Um die 4Bit Operation einzuschalten
			; lcdport=0x02;	//4 Bit Operation	
m014	MOVLW .2
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF lcdport
			;
			; PORTQ=lcdport;	//Auf den Port legen
	MOVF  lcdport,W
	MOVWF PORTQ
			; NOP;
	NOP  
			;
			; LCDCS_ON();	//High Nibble schreiben
	NOP  
	NOP  
	BSF   lcdport,6
	MOVF  lcdport,W
	MOVWF PORTQ
			; NOP;
	NOP  
			; NOP; 
	NOP  
			; LCDCS_OFF();
	NOP  
	NOP  
	BCF   lcdport,6
	MOVF  lcdport,W
	MOVWF PORTQ
			; Wait();
	MOVLW .10
	MOVWF _LcNB+8
	CLRF  _LcNB+9
	CALL  Delay1ms
			; LCDWriteByte(0x2C);    //4 Bit Operation,2 Line,5x7 Font  5
	MOVLW .44
	CALL  LCDWriteByte
			; Wait();
	MOVLW .10
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF _LcNB+8
	CLRF  _LcNB+9
	CALL  Delay1ms
			; LCDWriteByte(0x14); 	//Cursor Move,Right Shift
	MOVLW .20
	CALL  LCDWriteByte
			; Wait();
	MOVLW .10
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF _LcNB+8
	CLRF  _LcNB+9
	CALL  Delay1ms
			;
			; LCDWriteByte(0x0C); 	//Display on, Cursor off ,Cursor no blink
	MOVLW .12
	CALL  LCDWriteByte
			; Wait();
	MOVLW .10
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF _LcNB+8
	CLRF  _LcNB+9
	CALL  Delay1ms
			;
			; LCDWriteByte(0x06); 	//Increment, Display Freeze
	MOVLW .6
	CALL  LCDWriteByte
			; Wait();
	MOVLW .10
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF _LcNB+8
	CLRF  _LcNB+9
	CALL  Delay1ms
			; LCDWriteByte(0x02); 	//Cursor Home
	MOVLW .2
	CALL  LCDWriteByte
			; Wait();
	MOVLW .10
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF _LcNB+8
	CLRF  _LcNB+9
	CALL  Delay1ms
			; LCDRS_ON();		//LCD-Datenregister
	NOP  
	NOP  
	BCF   0x03,RP0
	BCF   0x03,RP1
	BSF   lcdport,4
	MOVF  lcdport,W
	MOVWF PORTQ
			;
			; LCDCommand(CLEAR_DISPLAY);
	MOVLW .1
	CALL  LCDCommand
			; Wait();
	MOVLW .10
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF _LcNB+8
	CLRF  _LcNB+9
	CALL  Delay1ms
			; 
			;//Die eigenen Character ins CGRAM schreiben
			;
			;//Der interne Adresszhler des LCD-Displays luft
			;//nach jedem Schreibzugriff automatisch hoch
			;
			; LCDCommand(0x48);//CG_RAM Adresse(1) setzen
	MOVLW .72
	CALL  LCDCommand
			;
			; for(i=0; i<CGRAM_LEN; i++) //8 Codes pro Zeichen bertragen
	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  _LcNB+2
m015	BCF   0x03,RP0
	BCF   0x03,RP1
	BTFSC _LcNB+2,7
	GOTO  m016
	MOVLW .24
	SUBWF _LcNB+2,W
	BTFSC 0x03,Carry
	GOTO  m017
			;  {
			;   LCDWriteByte(chardefs[i]);
m016	MOVLW .128
	BCF   0x03,RP0
	BCF   0x03,RP1
	ADDWF _LcNB+2,W
	CALL  _const1
	CALL  LCDWriteByte
			;  }
	BCF   0x03,RP0
	BCF   0x03,RP1
	INCF  _LcNB+2,1
	GOTO  m015
			;
			;
			; LCDCommand(0x80); //DD_RAM Adresse 0 setzen
m017	MOVLW .128
	GOTO  LCDCommand
			;}
			;
			;#ifdef _DEBUG
			;/*------------------------------------------------------------------*/
			;/*  Konvertiert 16 Bit Binaer zu Hexadezimal-ASCII 4-stellig        */
			;/*------------------------------------------------------------------*/
			;void Dez4Hex(uns16 zahl)
			;{
			;	char  count, help;
			;
			;	for (count = 0; count < 4; count++)
			;	{
			;		
			;		help = zahl & 0x000F;
			;		
			;		if (help > 9)
			;		{
			;			Text[3 - count] = help + 0x37;
			;		}
			;		else
			;		{
			;			Text[3 - count] = help + 0x30;
			;		}
			;		zahl >>=4;
			;	}
			;}
			;#endif
			;
			;/*------------------------------------------------------------------*/
			;/*  Konvertiert 16 Bit Binaer zu Dezimal-ASCII 3-stellig            */
			;/*------------------------------------------------------------------*/
			;void bin2dec999(uns16 Num)
			;{
bin2dec999
			;#asm
			;;Binary to decimal conversion (0..999)
			;;
			;;Input: Num+1:Num
			;;Output Hund:Tens:Ones (-> per define auf Text[])
			;;
			;;If Input > 999 Output will roll over, e.g.
			;;for input=5678 output=678.
			;;
			;;
			;;Size: 34 instructions
			;;Execution  time  (max) including return:
			;;22+5*9-1+5*6-1+4*3-1+2 = 108 cycles
			;;
			;;5-July-2000 by Nikolai Golovchenko
			;
			;
			;        movf Num+1, w
	MOVF  _LcNB+3,W
			;        addlw 241
	ADDLW .241
			;        addwf Num+1, w
	ADDWF _LcNB+3,W
			;        movwf Hund      ;b_2 = 2a_2 - 15
	MOVWF Text+1
			;
			;        addwf Hund, w
	ADDWF Text+1,W
			;        addwf Hund, w
	ADDWF Text+1,W
			;        addlw 253
	ADDLW .253
			;        movwf Tens
	MOVWF Text+2
			;        swapf Num, w
	SWAPF _LcNB+2,W
			;        andlw 0x0F
	ANDLW .15
			;        addwf Tens, f
	ADDWF Text+2,1
			;        addwf Tens, f   ;b_1 = 6a_2 + 2a_1 - 48
	ADDWF Text+2,1
			;
			;        addwf Num+1, w
	ADDWF _LcNB+3,W
			;        sublw 251
	SUBLW .251
			;        movwf Ones
	MOVWF Text+4
			;        addwf Ones, f
	ADDWF Text+4,1
			;        addwf Ones, f
	ADDWF Text+4,1
			;        addwf Ones, f
	ADDWF Text+4,1
			;        movf Num, w
	MOVF  _LcNB+2,W
			;        andlw 0x0F
	ANDLW .15
			;        addwf Ones, f   ;b_0 = a_0 - 4(a_2 + a_1) - 20
	ADDWF Text+4,1
			;
			;        movlw 10
	MOVLW .10
			;bin2dec999a                     ;9 cycles max
			;        addwf Ones, f
m018	ADDWF Text+4,1
			;        decf Tens, f
	DECF  Text+2,1
			;        btfss 3,Carry
	BTFSS 0x03,Carry
			;         goto bin2dec999a
	GOTO  m018
			;
			;bin2dec999b                     ;6 cycles max
			;        addwf Tens, f
m019	ADDWF Text+2,1
			;        decf Hund, f
	DECF  Text+1,1
			;        btfss 3,Carry
	BTFSS 0x03,Carry
			;         goto bin2dec999b
	GOTO  m019
			;
			;bin2dec999c                     ;3 cycles max
			;        addwf Hund, f
m020	ADDWF Text+1,1
			;        btfss 3,Carry
	BTFSS 0x03,Carry
			;         goto bin2dec999c
	GOTO  m020
			;
			;#endasm
			;	Text[1] +=0x30;
	MOVLW .48
	BCF   0x03,RP0
	BCF   0x03,RP1
	ADDWF Text+1,1
			;	Text[2] +=0x30;
	MOVLW .48
	ADDWF Text+2,1
			;	Text[3] ='.';
	MOVLW .46
	MOVWF Text+3
			;	Text[4] +=0x30;
	MOVLW .48
	ADDWF Text+4,1
			;}
	RETURN
			;
			;
			;
			;
			;/*------------------------------------------------------------------*/
			;/*   MM     MM    AA  TTTTTT HH   HH                                */
			;/*   MMM   MMM  AA  AA  TT   HH   HH                                */
			;/*   MM M M MM  AAAAAA  TT   HHHHHHH                                */
			;/*   MM  M  MM  AA  AA  TT   HH   HH                                */
			;/*   Mm     MM  AA  AA  TT   HH   HH                                */
			;/*------------------------------------------------------------------*/
			;
			;
			;
			;void mul16(uns16 n1, uns16 n2)
			;{
mul16
			;
			;#asm
			;;*******************************************************************
			;; Double Precision Multiplication
			;;
			;; n_2 : n_1 * n_4 : n_3 -> q_4:q_3:q_2:q_1
			;;
			;; Standard shift and add.
			;; Execution time: 215 to 295 clock cycles.
			;; Code space: 22 locations
			;;
			;; Cleaned up and corrected version from Microchip Ap note by BF.
			;; Note: Ap note has errors! Additional mods by Scott Dattalo.
			;;
			;;*******************************************************************
			;
			;	clrf q+3
	CLRF  q+3
			;	clrf q+2
	CLRF  q+2
			;	clrf q+1
	CLRF  q+1
			;	clrf q	
	CLRF  q
			;	bsf q+1, 7	
	BSF   q+1,7
			;m1:
			;	rrf n1+1, f
m021	RRF   _LcNB+3,1
			;	rrf n1, f
	RRF   _LcNB+2,1
			;	btfss 3,Carry  ; skpc
	BTFSS 0x03,Carry
			;	goto m2
	GOTO  m022
			;	movf n2, w
	MOVF  _LcNB+4,W
			;	addwf q+2, f
	ADDWF q+2,1
			;	movf n2+1, w
	MOVF  _LcNB+5,W
			;	btfsc 3,Carry  ; skpnc
	BTFSC 0x03,Carry
			;	incfsz n2+1, w
	INCFSZ _LcNB+5,W
			;	addwf q+3, f
	ADDWF q+3,1
			;m2:
			;	rrf q+3, f
m022	RRF   q+3,1
			;	rrf q+2, f
	RRF   q+2,1
			;	rrf q+1, f
	RRF   q+1,1
			;	rrf q, f
	RRF   q,1
			;	btfss   3,Carry   ;skpc
	BTFSS 0x03,Carry
			;	goto m1
	GOTO  m021
			;#endasm
			;
			;}
	RETURN
			;        
			;        
			;void divide()
			;{       
divide
			;        
			;	uns16 REM;  	// Divisionsrest -> Discard
			;	uns8 LOOPCOUNT;
			;
			;#asm    
			;        
			;;Inputs:
			;;   Dividend - AARGB0:AARGB1:AARGB2 (0 - most significant!)
			;;   Divisor  - BARGB0:BARGB1
			;;Temporary:
			;;   Counter  - LOOPCOUNT
			;;   Remainder- REMB0:REMB1
			;;Output:
			;;   Quotient - AARGB0:AARGB1:AARGB2	  
			;        
			;FXD2416U:
			;            clrf REM
	CLRF  _LcNB+2
			;            clrf REM+1
	CLRF  _LcNB+3
			;            movlw .24
	MOVLW .24
			;            movwf LOOPCOUNT
	MOVWF _LcNB+4
			;LOOPU2416:
			;            rlf q, W           ;shift dividend left to move next bit to remainder
m023	RLF   q,W
			;            rlf q+1, F           ;
	RLF   q+1,1
			;            rlf q+2, F           ;
	RLF   q+2,1
			;        
			;            rlf REM+1, F            ;shift carry (next dividend bit) into remainder
	RLF   _LcNB+3,1
			;            rlf REM, F
	RLF   _LcNB+2,1
			;        
			;            rlf q, F           ;finish shifting the dividend and save  carry in AARGB2.0,
	RLF   q,1
			;                                    ;since remainder can be 17 bit long in some cases
			;                                    ;(e.g. 0x800000/0xFFFF). This bit will also serve
			;                                    ;as the next result bit.
			;             
			;            movf t_low, W          ;substract divisor from 16-bit remainder
	MOVF  t_low,W
			;            subwf REM+1, F          ;
	SUBWF _LcNB+3,1
			;            movf t_low+1, W          ;
	MOVF  t_low+1,W
			;            btfss STATUS, Carry         ;
	BTFSS 0x03,Carry
			;            incfsz t_low+1, W        ;
	INCFSZ t_low+1,W
			;            subwf REM, F          ;
	SUBWF _LcNB+2,1
			;
			;    ;here we also need to take into account the 17th bit of remainder, which
			;    ;is in AARGB2.0. If we don't have a borrow after subtracting from lower
			;    ;16 bits of remainder, then there is no borrow regardless of 17th bit 
			;    ;value. But, if we have the borrow, then that will depend on 17th bit 
			;    ;value. If it is 1, then no final borrow will occur. If it is 0, borrow
			;    ;will occur. These values match the borrow flag polarity.
			;
			;            btfsc 3,Carry           ;skpnc - if no borrow after 16 bit subtraction
	BTFSC 0x03,Carry
			;             bsf q, 0          ;then there is no borrow in result. Overwrite
	BSF   q,0
			;                                    ;AARGB2.0 with 1 to indicate no
			;                                    ;borrow.
			;                                    ;if borrow did occur, AARGB2.0 already
			;                                    ;holds the final borrow value (0-borrow,
			;                                    ;1-no borrow)
			;
			;            btfsc q, 0         ;if no borrow after 17-bit subtraction
	BTFSC q,0
			;             goto UOK46LL           ;skip remainder restoration.
	GOTO  m024
			;
			;            addwf REM, F          ;restore higher byte of remainder. (w 
	ADDWF _LcNB+2,1
			;                                    ;contains the value subtracted from it
			;                                    ;previously)
			;            movf t_low, W          ;restore lower byte of remainder
	MOVF  t_low,W
			;            addwf REM+1, F          ;
	ADDWF _LcNB+3,1
			;
			;UOK46LL:
			;
			;            decfsz LOOPCOUNT, f     ;decrement counter
m024	DECFSZ _LcNB+4,1
			;             goto LOOPU2416         ;and repeat the loop if not zero.
	GOTO  m023
			;
			; #endasm         
			;            
			;}
	RETURN
			;
			;/*------------------------------------------------------------------*/
			;/*     AA    PPPP   PPPP                                            */
			;/*   AA  AA  PP PP  PP PP                                           */
			;/*   AAAAAA  PPPP   PPPP                                            */
			;/*   AA  AA  PP     PP                                              */
			;/*   AA  AA  PP     PP                                             */
			;/*------------------------------------------------------------------*/
			;
			;
			;// #######################################
			;//  Temp1 / Gefrierfach messen
			;// #######################################
			;void Measure_G(void)
			;{
Measure_G
			;	T1CON=0b0011.0000;  // Timer1 int, div8, stop
	MOVLW .48
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF T1CON
			;	TMR1H=0;
	CLRF  TMR1H
			;	TMR1L=0;
	CLRF  TMR1L
			;	TMR1IF=0;
	BCF   0x0C,TMR1IF
			;	//T1CON=0b0011.0001;  // Timer1 int, div8, run
			;	TMR1ON=1;
	BSF   0x10,TMR1ON
			;#pragma updateBank 0 /* OFF, all cores */
			;
			;	while ((!TMP_1)&&(!TMR1IF))//&&(t_low)
m025	BTFSC 0x06,RB0
	GOTO  m026
	BTFSC 0x0C,TMR1IF
	GOTO  m026
			;	{
			;	};
	GOTO  m025
			;	//T1CON=0b0011.0000;  // Timer1 int, div8, stop
			;	TMR1ON=0;
m026	BCF   0x10,TMR1ON
			;	t_low.low8 = TMR1L;
	MOVF  TMR1L,W
	MOVWF t_low
			;	t_low.high8 = TMR1H;
	MOVF  TMR1H,W
	MOVWF t_low+1
			;	
			;	TMR1H=0;
	CLRF  TMR1H
			;	TMR1L=0;
	CLRF  TMR1L
			;	//T1CON=0b0011.0001;  // Timer1 int, div8, run
			;	TMR1ON=1;
	BSF   0x10,TMR1ON
			;	while ((TMP_1)&&(!TMR1IF))//&&(t_high)
m027	BTFSS 0x06,RB0
	GOTO  m028
	BTFSC 0x0C,TMR1IF
	GOTO  m028
			;	{
			;	};
	GOTO  m027
			;	//T1CON=0b0010.0000;  // Timer1 int, div8, stop
			;	TMR1ON=0;
m028	BCF   0x10,TMR1ON
			;	t_high.low8 = TMR1L;
	MOVF  TMR1L,W
	MOVWF t_high
			;	t_high.high8 = TMR1H;
	MOVF  TMR1H,W
	MOVWF t_high+1
			;	
			;	
			;	TMR1H=0;
	CLRF  TMR1H
			;	TMR1L=0;
	CLRF  TMR1L
			;	//T1CON=0b0010.0001;  // Timer1 int, div8, run
			;	TMR1ON=1;
	BSF   0x10,TMR1ON
			;	while ((!TMP_1)&&(!TMR1IF))//&&(t_low)
m029	BTFSC 0x06,RB0
	GOTO  m030
	BTFSC 0x0C,TMR1IF
	GOTO  m030
			;	{
			;	};
	GOTO  m029
			;	//T1CON=0b0010.0000;  // Timer1 int, div8, stop
			;	TMR1ON=0;
m030	BCF   0x10,TMR1ON
			;	t_low.low8 = TMR1L;
	MOVF  TMR1L,W
	MOVWF t_low
			;	t_low.high8 = TMR1H;
	MOVF  TMR1H,W
	MOVWF t_low+1
			;	
			;	TMR1H=0;
	CLRF  TMR1H
			;	TMR1L=0;
	CLRF  TMR1L
			;	//T1CON=0b0010.0001;  // Timer1 int, div8, run
			;	TMR1ON=1;
	BSF   0x10,TMR1ON
			;	while ((TMP_1)&&(!TMR1IF))//&&(t_high)
m031	BTFSS 0x06,RB0
	GOTO  m032
	BTFSC 0x0C,TMR1IF
	GOTO  m032
			;	{
			;	};
	GOTO  m031
			;	//T1CON=0b0010.0000;  // Timer1 int, div8, stop
			;	TMR1ON=0;
m032	BCF   0x10,TMR1ON
			;	t_high.low8 = TMR1L;
	MOVF  TMR1L,W
	MOVWF t_high
			;	t_high.high8 = TMR1H;
	MOVF  TMR1H,W
	MOVWF t_high+1
			;
			;	F_SensorG|=TMR1IF;
	BTFSC 0x0C,TMR1IF
	BSF   _GbitVB+0,1
			;	
			;#pragma updateBank 1 /* ON, all cores */
			;}
	RETURN
			;// #######################################
			;//  Temp2 / Kuehlfach messen
			;// #######################################
			;void Measure_K(void)
			;{
Measure_K
			;	T1CON=0b0011.0000;  // Timer1 int, div8, stop
	MOVLW .48
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF T1CON
			;	TMR1H=0;
	CLRF  TMR1H
			;	TMR1L=0;
	CLRF  TMR1L
			;	TMR1IF=0;
	BCF   0x0C,TMR1IF
			;	//T1CON=0b0011.0001;  // Timer1 int, div8, run
			;	TMR1ON=1;
	BSF   0x10,TMR1ON
			;#pragma updateBank 0 /* OFF, all cores */
			;
			;	while ((!TMP_2)&&(!TMR1IF))//&&(t_low)
m033	BTFSC 0x06,RB1
	GOTO  m034
	BTFSC 0x0C,TMR1IF
	GOTO  m034
			;	{
			;	};
	GOTO  m033
			;	//T1CON=0b0011.0000;  // Timer1 int, div8, stop
			;	TMR1ON=0;
m034	BCF   0x10,TMR1ON
			;	t_low.low8 = TMR1L;
	MOVF  TMR1L,W
	MOVWF t_low
			;	t_low.high8 = TMR1H;
	MOVF  TMR1H,W
	MOVWF t_low+1
			;	
			;	TMR1H=0;
	CLRF  TMR1H
			;	TMR1L=0;
	CLRF  TMR1L
			;	//T1CON=0b0011.0001;  // Timer1 int, div8, run
			;	TMR1ON=1;
	BSF   0x10,TMR1ON
			;	while ((TMP_2)&&(!TMR1IF))//&&(t_high)
m035	BTFSS 0x06,RB1
	GOTO  m036
	BTFSC 0x0C,TMR1IF
	GOTO  m036
			;	{
			;	};
	GOTO  m035
			;	//T1CON=0b0010.0000;  // Timer1 int, div8, stop
			;	TMR1ON=0;
m036	BCF   0x10,TMR1ON
			;	t_high.low8 = TMR1L;
	MOVF  TMR1L,W
	MOVWF t_high
			;	t_high.high8 = TMR1H;
	MOVF  TMR1H,W
	MOVWF t_high+1
			;	
			;	
			;	TMR1H=0;
	CLRF  TMR1H
			;	TMR1L=0;
	CLRF  TMR1L
			;	//T1CON=0b0010.0001;  // Timer1 int, div8, run
			;	TMR1ON=1;
	BSF   0x10,TMR1ON
			;	while ((!TMP_2)&&(!TMR1IF))//&&(t_low)
m037	BTFSC 0x06,RB1
	GOTO  m038
	BTFSC 0x0C,TMR1IF
	GOTO  m038
			;	{
			;	};
	GOTO  m037
			;	//T1CON=0b0010.0000;  // Timer1 int, div8, stop
			;	TMR1ON=0;
m038	BCF   0x10,TMR1ON
			;	t_low.low8 = TMR1L;
	MOVF  TMR1L,W
	MOVWF t_low
			;	t_low.high8 = TMR1H;
	MOVF  TMR1H,W
	MOVWF t_low+1
			;	
			;	TMR1H=0;
	CLRF  TMR1H
			;	TMR1L=0;
	CLRF  TMR1L
			;	//T1CON=0b0010.0001;  // Timer1 int, div8, run
			;	TMR1ON=1;
	BSF   0x10,TMR1ON
			;	while ((TMP_2)&&(!TMR1IF))//&&(t_high)
m039	BTFSS 0x06,RB1
	GOTO  m040
	BTFSC 0x0C,TMR1IF
	GOTO  m040
			;	{
			;	};
	GOTO  m039
			;	//T1CON=0b0010.0000;  // Timer1 int, div8, stop
			;	TMR1ON=0;
m040	BCF   0x10,TMR1ON
			;	t_high.low8 = TMR1L;
	MOVF  TMR1L,W
	MOVWF t_high
			;	t_high.high8 = TMR1H;
	MOVF  TMR1H,W
	MOVWF t_high+1
			;
			;	F_SensorK|=TMR1IF;
	BTFSC 0x0C,TMR1IF
	BSF   _GbitVB+0,2
			;	
			;#pragma updateBank 1 /* ON, all cores */
			;}
	RETURN
			;// #######################################
			;//  Kompressor an und aus
			;// #######################################
			;void Komp_An(void)
			;{
Komp_An
			;#pragma updateBank 0 /* OFF, all cores */
			;
			;	// Wenn keine Schutzzeit, einschalten
			;	if (!Komp_prtkt)
	MOVF  Komp_prtkt,W
	IORWF Komp_prtkt+1,W
	BTFSS 0x03,Zero_
	GOTO  m041
			;	{
			;		Komp_ON = 1;
	BSF   _GbitVB+0,0
			;		Komp_OnTime =0;
	CLRF  Komp_OnTime
	CLRF  Komp_OnTime+1
			;		F_MotorMax = 0;
	BCF   _GbitVB+0,3
			;		KOMP_RELAIS = 1;
	BSF   0x06,RB3
			;	}
			;#pragma updateBank 1 /* ON, all cores */
			;}
m041	RETURN
			;
			;void Komp_Aus(void)
			;{
Komp_Aus
			;#pragma updateBank 0 /* OFF, all cores */
			;
			;	Komp_prtkt = KOMP_PROT;
	MOVLW .60
	MOVWF Komp_prtkt
	CLRF  Komp_prtkt+1
			;	KOMP_RELAIS = 0;
	BCF   0x06,RB3
			;	Komp_ON = 0;
	BCF   _GbitVB+0,0
			;	
			;#pragma updateBank 1 /* ON, all cores */
			;}
	RETURN
			;
			;// #######################################
			;//  Kompressorschutz
			;// #######################################
			;void Komp_Control(void)
			;{
Komp_Control
			;#pragma updateBank 0 /* OFF, all cores */
			;
			;	// Kompressor soll gestartet werden
			;	if ((Komp_Req) && (!Komp_ON))
	BTFSS _GbitVB+0,4
	GOTO  m042
	BTFSC _GbitVB+0,0
	GOTO  m042
			;	{
			;		Komp_An();	
	CALL  Komp_An
			;	}
			;	// Kompressor soll gestartet werden
			;	else if ((!Komp_Req) && (Komp_ON))
	GOTO  m043
m042	BTFSC _GbitVB+0,4
	GOTO  m043
	BTFSS _GbitVB+0,0
	GOTO  m043
			;	{
			;		Komp_Aus();
	CALL  Komp_Aus
			;	}
			;	
			;	// wenn Kompressor luft
			;	if (Komp_ON)
m043	BTFSS _GbitVB+0,0
	GOTO  m046
			;	{
			;		Komp_OnTime++;
	INCF  Komp_OnTime,1
	BTFSC 0x03,Zero_
	INCF  Komp_OnTime+1,1
			;		
			;		// Maximale Laufzeit berschritten
			;		if (Komp_OnTime > KOMP_MAXRUN)
	MOVLW .1
	SUBWF Komp_OnTime+1,W
	BTFSS 0x03,Carry
	GOTO  m045
	BTFSS 0x03,Zero_
	GOTO  m044
	MOVLW .45
	SUBWF Komp_OnTime,W
	BTFSS 0x03,Carry
	GOTO  m045
			;		{
			;			Komp_Aus();
m044	CALL  Komp_Aus
			;			F_MotorMax=1;
	BSF   _GbitVB+0,3
			;		}
			;	}
			;	else
m045	GOTO  m047
			;	{
			;		// Wenn Kompressor aus, Schutzzeit zurueckzaehlen
			;		if (Komp_prtkt)
m046	MOVF  Komp_prtkt,W
	IORWF Komp_prtkt+1,W
	BTFSC 0x03,Zero_
	GOTO  m047
			;		{
			;			Komp_prtkt--;
	DECF  Komp_prtkt,1
	INCF  Komp_prtkt,W
	BTFSC 0x03,Zero_
	DECF  Komp_prtkt+1,1
			;		}
			;	}
			;#pragma updateBank 1 /* ON, all cores */
			;}
m047	RETURN
			;
			;
			;// #######################################
			;//  R E G L E R
			;// #######################################
			;void Regler(void)
			;{
Regler
			;#pragma updateBank 0 /* OFF, all cores */
			;	
			;	// Einschaltern
			;	if ((temp_G > G_TEMP_MAX) || (temp_K > K_TEMP_MAX))
	BTFSS temp_G+1,7
	GOTO  m049
	INCF  temp_G+1,W
	BTFSS 0x03,Zero_
	GOTO  m048
	MOVLW .172
	SUBWF temp_G,W
	BTFSC 0x03,Carry
	GOTO  m049
m048	BTFSC temp_K+1,7
	GOTO  m050
	MOVF  temp_K+1,W
	BTFSS 0x03,Zero_
	GOTO  m049
	MOVLW .41
	SUBWF temp_K,W
	BTFSS 0x03,Carry
	GOTO  m050
			;	{
			;		Komp_Req = 1;	
m049	BSF   _GbitVB+0,4
			;	}
			;	// Ausschalten
			;	else if ((temp_G < G_TEMP_MIN) && (temp_K < K_TEMP_MIN))
	GOTO  m053
m050	BTFSS temp_G+1,7
	GOTO  m053
	INCF  temp_G+1,W
	BTFSS 0x03,Zero_
	GOTO  m051
	MOVLW .146
	SUBWF temp_G,W
	BTFSC 0x03,Carry
	GOTO  m053
m051	BTFSC temp_K+1,7
	GOTO  m052
	MOVF  temp_K+1,W
	BTFSS 0x03,Zero_
	GOTO  m053
	MOVLW .32
	SUBWF temp_K,W
	BTFSC 0x03,Carry
	GOTO  m053
			;	{
			;		Komp_Req = 0;	
m052	BCF   _GbitVB+0,4
			;	}
			;	
			;	// Ausschalten Frostschutz 
			;	if (temp_K < K_FROST_MIN)
m053	BTFSC temp_K+1,7
	GOTO  m054
	MOVF  temp_K+1,W
	BTFSS 0x03,Zero_
	GOTO  m055
	MOVLW .15
	SUBWF temp_K,W
	BTFSC 0x03,Carry
	GOTO  m055
			;	{
			;		Komp_Req = 0;
m054	BCF   _GbitVB+0,4
			;		F_Frost  = 1;
	BSF   _GbitVB+0,5
			;	}
			;	else
	GOTO  m056
			;	{
			;		F_Frost = 0;
m055	BCF   _GbitVB+0,5
			;	}
			;	
			;#pragma updateBank 1 /* ON, all cores */	
			;}
m056	RETURN
			;
			;// #######################################
			;//  Temperatur aus t_hig, t_low berechnen
			;// #######################################	
			;void Berechnen(void)
			;{
Berechnen
			;#pragma updateBank 0 /* OFF, all cores */
			;
			;	// Alle Temperaturen in 0.2Grad Aufloesung
			;	
			;	// t_high * 400 
			;	mul16(t_high,2000);
	MOVF  t_high,W
	MOVWF _LcNB+2
	MOVF  t_high+1,W
	MOVWF _LcNB+3
	MOVLW .208
	MOVWF _LcNB+4
	MOVLW .7
	MOVWF _LcNB+5
	CALL  mul16
			;	//  div by t_low
			;	divide();
	CALL  divide
			;	
			;	t_low.high8=q[1];
	MOVF  q+1,W
	MOVWF t_low+1
			;	t_low.low8=q[0];
	MOVF  q,W
	MOVWF t_low
			;	
			;	// Temperatur = 235-(...) 
			;	Temperatur = (int16)1160-(int16)t_low; // Temperatur enhlt jetzt die Temperatur in 0.2 Grad steps + sign
	MOVF  t_low+1,W
	SUBLW .4
	MOVWF Temperatur+1
	MOVF  t_low,W
	SUBLW .136
	MOVWF Temperatur
	BTFSS 0x03,Carry
	DECF  Temperatur+1,1
			;	
			;#pragma updateBank 1 /* ON, all cores */
			;}
	RETURN
			;
			;// ##################################
			;//  Temperatur nach ASCII
			;// ##################################	
			;void Format_Temp(void)
			;{
Format_Temp
			;#pragma updateBank 0 /* OFF, all cores */
			;
			;	// Temperatur in ASCII + Vorzeichen
			;	if (VZ_merker)
	BTFSS _GbitVB+0,6
	GOTO  m057
			;	{ 
			;		bin2dec999(-Temperatur);
	COMF  Temperatur+1,W
	MOVWF _LcNB+3
	COMF  Temperatur,W
	MOVWF _LcNB+2
	INCF  _LcNB+2,1
	BTFSC 0x03,Zero_
	INCF  _LcNB+3,1
	CALL  bin2dec999
			;		Text[0]='-';
	MOVLW .45
	MOVWF Text
			;	}
			;	else
	GOTO  m058
			;	{
			;		bin2dec999(Temperatur);
m057	MOVF  Temperatur,W
	MOVWF _LcNB+2
	MOVF  Temperatur+1,W
	MOVWF _LcNB+3
	CALL  bin2dec999
			;		Text[0]='+';
	MOVLW .43
	MOVWF Text
			;	}
			;	
			;#pragma updateBank 1 /* ON, all cores */	
			;}
m058	RETURN
			;
			;// ##################################
			;//  Temperatur plausibilisieren
			;// ##################################	
			;void Check_Temp(void)
			;{
Check_Temp
			;#pragma updateBank 0 /* OFF, all cores */
			;
			;	if (Temperatur > K_CHECK_MAX )
	BTFSC Temperatur+1,7
	GOTO  m060
	MOVF  Temperatur+1,W
	BTFSS 0x03,Zero_
	GOTO  m059
	MOVLW .201
	SUBWF Temperatur,W
	BTFSS 0x03,Carry
	GOTO  m060
			;		VZ_merker = 1;
m059	BSF   _GbitVB+0,6
			;	else if (Temperatur < K_CHECK_MIN)
	GOTO  m063
m060	BTFSS Temperatur+1,7
	GOTO  m062
	INCF  Temperatur+1,W
	BTFSS 0x03,Zero_
	GOTO  m061
	MOVLW .81
	SUBWF Temperatur,W
	BTFSC 0x03,Carry
	GOTO  m062
			;		VZ_merker = 1;
m061	BSF   _GbitVB+0,6
			;	else
	GOTO  m063
			;		VZ_merker = 0;
m062	BCF   _GbitVB+0,6
			;		
			;		
			;#pragma updateBank 1 /* ON, all cores */
			;}
m063	RETURN
			;
			;// ##################################
			;//  Text fr Sensorfehler setzen
			;// ##################################	
			;void ErrorText(void)
			;{
ErrorText
			;#asm  
			;			;	Text[0,1,2,5] = '-';
			;	movlw .45
	MOVLW .45
			;	movwf Text
	MOVWF Text
			;	movwf Text+1
	MOVWF Text+1
			;	movwf Text+2
	MOVWF Text+2
			;	movwf Text+4
	MOVWF Text+4
			;			;	Text[3] = '.';
			;	movlw .46
	MOVLW .46
			;	movwf Text+3
	MOVWF Text+3
			;			;	Text[5] = 'E';	
			;	movlw .69
	MOVLW .69
			;	movwf Text+5
	MOVWF Text+5
			;#endasm
			;	LED_R = 0;
	BCF   0x03,RP0
	BCF   0x03,RP1
	BCF   0x06,RB4
			;}
	RETURN
			;
			;/*------------------------------------------------------------------*/
			;/*     M     M    A    II  N   N                                    */
			;/*     MM   MM   A A   II  NN  N                                    */
			;/*     M M M M  A   A  II  N N N                                    */
			;/*     M  M  M  AAAAA  II  N  NN                                    */
			;/*     M     M  A   A  II  N   N                                    */
			;/*------------------------------------------------------------------*/
			;
			;void main (void)
			;{
main
			;	uns8 ticks;
			;
			;	init();
	CALL  init
			;	
			;	LCDInit();	  // LCD Initialisieren
	CALL  LCDInit
			;		
			;	LCDCls();	 // Bildschirm lschen
	CALL  LCDCls
			;
			;// und ausgeben
			;	LCDPos(0,0);         
	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  _LcNB+2
	MOVLW .0
	CALL  LCDPos
			;	LCDString("DTemp1.4");
	MOVLW .152
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF _LcNB+2
	CALL  LCDString
			;	LCDPos(1,0);
	MOVLW .1
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF _LcNB+2
	MOVLW .0
	CALL  LCDPos
			;	LCDString("C.Schirp");
	MOVLW .161
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF _LcNB+2
	CALL  LCDString
			;	
			;	Delay1ms(10000);
	MOVLW .16
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF _LcNB+8
	MOVLW .39
	MOVWF _LcNB+9
	CALL  Delay1ms
			;	
			;
			;#pragma updateBank 0 /* OFF, all cores */
			;  
			;	while (1)
			;	{
			;		
			;		// todo
			;		// LCD schalten und initialisieren...?
			;		// Filterzeit verlngern
			;		
			;		LED_G = 0;	// Messungsanzeige an
m064	BCF   0x06,RB5
			;		LED_R = 1;	// Fehleranzeige aus
	BSF   0x06,RB4
			;		
			;		if (Blink)
	BTFSS _GbitVB+0,7
	GOTO  m065
			;			Text[7]=1;
	MOVLW .1
	MOVWF Text+7
			;		else if (F_MotorMax)
	GOTO  m067
m065	BTFSS _GbitVB+0,3
	GOTO  m066
			;			Text[7]=3;
	MOVLW .3
	MOVWF Text+7
			;		else
	GOTO  m067
			;			Text[7]=2;
m066	MOVLW .2
	MOVWF Text+7
			;		
			;		Blink ^=1;	// Blinker weiterzaehlen
m067	MOVLW .128
	XORWF _GbitVB,1
			;		
			;		// ##################################
			;		// Gefrierfach Messung durchfhren
			;		// ##################################		
			;		Measure_G();
	CALL  Measure_G
			;		Berechnen();
	CALL  Berechnen
			;		med_a = Temperatur;
	MOVF  Temperatur,W
	MOVWF med_a
	MOVF  Temperatur+1,W
	MOVWF med_a+1
			;		
			;		Measure_G();
	CALL  Measure_G
			;		Berechnen();
	CALL  Berechnen
			;		med_b = Temperatur;
	MOVF  Temperatur,W
	MOVWF med_b
	MOVF  Temperatur+1,W
	MOVWF med_b+1
			;		
			;		Measure_G();
	CALL  Measure_G
			;		Berechnen();
	CALL  Berechnen
			;		med_c = Temperatur;		
	MOVF  Temperatur,W
	MOVWF med_c
	MOVF  Temperatur+1,W
	MOVWF med_c+1
			;		
			;		MedianFilter();
	CALL  MedianFilter
			;
			;		Check_Temp();
	CALL  Check_Temp
			;		
			;		F_SensorG |= VZ_merker; // F_SensorX wird in Measure_X zurueckgesetzt
	BTFSC _GbitVB+0,6
	BSF   _GbitVB+0,1
			;
			;		 // Fehler?
			;		if (F_SensorG)
	BTFSS _GbitVB+0,1
	GOTO  m068
			;		{
			;			ErrorText();
	CALL  ErrorText
			;			temp_G = K_FAIL_TEMP_G; // Default-Temp fuer Komp. aus
	MOVLW .141
	MOVWF temp_G
	MOVLW .255
	MOVWF temp_G+1
			;		}
			;		else
	GOTO  m072
			;		{
			;			Text[5] = ' '; // ggfs. Fehlerausgabe loeschen
m068	MOVLW .32
	MOVWF Text+5
			;			
			;			// todo: Wenn fehler nicht regeln sondern Vertrauenszhler nutzen
			;			//
			;			
			;			// Filter (1xalt + 1xneu)
			;			temp_G+=Temperatur;
	MOVF  Temperatur+1,W
	ADDWF temp_G+1,1
	MOVF  Temperatur,W
	ADDWF temp_G,1
	BTFSC 0x03,Carry
	INCF  temp_G+1,1
			;			
			;			// Vorzeichen merken
			;			if (temp_G < 0)
	BTFSS temp_G+1,7
	GOTO  m069
			;			{
			;				VZ_merker = 1;
	BSF   _GbitVB+0,6
			;			}
			;			else
	GOTO  m070
			;			{
			;				VZ_merker = 0;
m069	BCF   _GbitVB+0,6
			;			}
			;			
			;			temp_G >>= 1; // Filter wieder normieren
m070	BSF   0x03,Carry
	BTFSS temp_G+1,7
	BCF   0x03,Carry
	RRF   temp_G+1,1
	RRF   temp_G,1
			;			
			;			if (VZ_merker)
	BTFSS _GbitVB+0,6
	GOTO  m071
			;				temp_G |= (uns16)0x8000;
	BSF   temp_G+1,7
			;			
			;			Temperatur=temp_G<<1;	// von 0.2 Grad auf 0.1 Grad normieren, bi2dec liefert dann xx.x
m071	BCF   0x03,Carry
	RLF   temp_G,W
	MOVWF Temperatur
	RLF   temp_G+1,W
	MOVWF Temperatur+1
			;			
			;			// nach ASCII wandlen
			;			Format_Temp();
	CALL  Format_Temp
			;		}
			;		// und ausgeben
			;		LCDPos(1,0);         
m072	MOVLW .1
	MOVWF _LcNB+2
	MOVLW .0
	CALL  LCDPos
			;		LCDString(Text);
	MOVLW LOW(Text+0)
	MOVWF _LcNB+2
	CALL  LCDString
			;		
			;		// ##################################
			;		//  Khlfach Messung durchfhren
			;		// ##################################		
			;		Measure_K();
	CALL  Measure_K
			;		Berechnen();
	CALL  Berechnen
			;		med_a = Temperatur;
	MOVF  Temperatur,W
	MOVWF med_a
	MOVF  Temperatur+1,W
	MOVWF med_a+1
			;		
			;		Measure_K();
	CALL  Measure_K
			;		Berechnen();
	CALL  Berechnen
			;		med_b = Temperatur;
	MOVF  Temperatur,W
	MOVWF med_b
	MOVF  Temperatur+1,W
	MOVWF med_b+1
			;		
			;		Measure_K();
	CALL  Measure_K
			;		Berechnen();
	CALL  Berechnen
			;		med_c = Temperatur;
	MOVF  Temperatur,W
	MOVWF med_c
	MOVF  Temperatur+1,W
	MOVWF med_c+1
			;		
			;		Check_Temp();
	CALL  Check_Temp
			;		
			;		F_SensorK |= VZ_merker;	// F_SensorX wird in Measure_X zurueckgesetzt
	BTFSC _GbitVB+0,6
	BSF   _GbitVB+0,2
			;		
			;		 // Fehler?
			;		if (F_SensorK)
	BTFSS _GbitVB+0,2
	GOTO  m073
			;		{
			;			ErrorText();
	CALL  ErrorText
			;			temp_K = K_FAIL_TEMP_K; // Default-Temp fuer Komp. aus
	MOVLW .30
	MOVWF temp_K
	CLRF  temp_K+1
			;		}
			;		else
	GOTO  m077
			;		{
			;			Text[5] = ' '; // ggfs. Fehlerausgabe loeschen
m073	MOVLW .32
	MOVWF Text+5
			;			
			;
			;			// Filter (1xalt + 1xneu)
			;			temp_K+=Temperatur;
	MOVF  Temperatur+1,W
	ADDWF temp_K+1,1
	MOVF  Temperatur,W
	ADDWF temp_K,1
	BTFSC 0x03,Carry
	INCF  temp_K+1,1
			;			
			;			// Vorzeichen merken
			;			if (temp_K < 0)
	BTFSS temp_K+1,7
	GOTO  m074
			;			{
			;				VZ_merker = 1;
	BSF   _GbitVB+0,6
			;			}
			;			else
	GOTO  m075
			;			{
			;				VZ_merker = 0;
m074	BCF   _GbitVB+0,6
			;			}
			;			
			;			temp_K >>= 1; // Filter wieder normieren
m075	BSF   0x03,Carry
	BTFSS temp_K+1,7
	BCF   0x03,Carry
	RRF   temp_K+1,1
	RRF   temp_K,1
			;			
			;			if (VZ_merker)
	BTFSS _GbitVB+0,6
	GOTO  m076
			;				temp_K |= (uns16)0x8000;
	BSF   temp_K+1,7
			;			
			;			Temperatur=temp_K<<1;	// von 0.2 Grad auf 0.1 Grad normieren, bi2dec liefert dann xx.x
m076	BCF   0x03,Carry
	RLF   temp_K,W
	MOVWF Temperatur
	RLF   temp_K+1,W
	MOVWF Temperatur+1
			;			
			;			// nach ASCII wandlen
			;			Format_Temp();
	CALL  Format_Temp
			;			
			;		}
			;		
			;		// Regelalgo ausfhren	
			;		Regler();
m077	CALL  Regler
			;			
			;		// Und Kompressor bedienen
			;		Komp_Control();
	CALL  Komp_Control
			;		
			;		if (Komp_ON)
	BTFSS _GbitVB+0,0
	GOTO  m078
			;			Text[7]='K';
	MOVLW .75
	MOVWF Text+7
			;		else
	GOTO  m079
			;			Text[7]=' ';
m078	MOVLW .32
	MOVWF Text+7
			;			
			;		// und ausgeben
			;		LCDPos(0,0);         
m079	CLRF  _LcNB+2
	MOVLW .0
	CALL  LCDPos
			;		LCDString(Text);
	MOVLW LOW(Text+0)
	MOVWF _LcNB+2
	CALL  LCDString
			;		
			;		// Fehlermerker resetten
			;		F_SensorK=0;
	BCF   _GbitVB+0,2
			;		F_SensorG=0;
	BCF   _GbitVB+0,1
			;		
			;		LED_G = 1;	// Messungsanzeige aus
	BSF   0x06,RB5
			;		
			;		Delay1ms(10000);	// Messtakt: 10s
	MOVLW .16
	MOVWF _LcNB+8
	MOVLW .39
	MOVWF _LcNB+9
	CALL  Delay1ms
			;
			;
			;	}; 
	GOTO  m064
			;#pragma updateBank 1 /* ON, all cores */
m080	SLEEP
	GOTO main

	END


; *** KEY INFO ***

; 0x0286    6 word(s)  0 % : Komp_Aus
; 0x0004   11 word(s)  0 % : int_server
; 0x0053   36 word(s)  1 % : init
; 0x0077   26 word(s)  1 % : Delay1ms
; 0x0091   51 word(s)  2 % : LCDWriteByte
; 0x00C4   18 word(s)  0 % : LCDCommand
; 0x00D6   20 word(s)  0 % : LCDCls
; 0x00EA   18 word(s)  0 % : LCDString
; 0x000F   68 word(s)  3 % : _const1
; 0x00FC   15 word(s)  0 % : LCDPos
; 0x010B  157 word(s)  7 % : LCDInit
; 0x01A8   44 word(s)  2 % : bin2dec999
; 0x01D4   22 word(s)  1 % : mul16
; 0x01EA   26 word(s)  1 % : divide
; 0x0204   60 word(s)  2 % : Measure_G
; 0x0240   60 word(s)  2 % : Measure_K
; 0x027C   10 word(s)  0 % : Komp_An
; 0x028C   38 word(s)  1 % : Komp_Control
; 0x02B2   53 word(s)  2 % : Regler
; 0x02E7   23 word(s)  1 % : Berechnen
; 0x02FE   21 word(s)  1 % : Format_Temp
; 0x0313   24 word(s)  1 % : Check_Temp
; 0x032B   13 word(s)  0 % : ErrorText
; 0x0338  192 word(s)  9 % : main

; RAM usage: 46 bytes (11 local), 178 bytes free
; Maximum call level: 3 (+1 for interrupt)
; Total of 1013 code words (49 %)
